// Copyright (C) 2022 - 2023, Xilinx Inc - All rights reserved
//
// Licensed under the Apache License, Version 2.0 (the "License"). You may
// not use this file except in compliance with the License. A copy of the
// License is located at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
// WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
// License for the specific language governing permissions and limitations
// under the License.

#pragma once

#include "Session.h"

namespace xma {
//////////////////////////////////////////////////////////////////////////////
typedef int32_t (*DecPropChangeCallbackFunction)(FramePropertiesPtr new_props, void* opaque);

class DecoderSession : virtual public Session {
protected:
  DecoderSession() = default;

public:
  virtual ~DecoderSession() = default;

  virtual FramePropertiesPtr GetProps() const = 0;
};

using DecoderSessionPtr = std::shared_ptr<DecoderSession>;

}; // Namespace xma
